# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/), and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [2.10.2] - 2023-11-26

__Fix:__ Reference `version` correctly (from under `kitten` namespace).
__Add:__ All `version` properties and methods from new Version class. 

## [2.10.1] - 2023-11-16

__Change:__ The `version.date` property is now a `Date` instance instead of a string date stamp.

## [2.10.0] - 2023-11-16

__Add:__ `version` property that has current Kitten version information.

## [2.9.0] - 2023-11-03

__Add:__ `downloadPath` property that serves an uploaded file using `content-disposition: attachment` instead of the default `content-disposition: inline` used by the `resourcePath` property.

## [2.8.1] - 2023-11-01

__Change:__ Include concrete class implementation of Upload instead of just its type definition as it is required when storing Upload instances in custom databases in Kitten apps.

## [2.8.0] - 2023-10-31

__Add:__ Add `resourcePath` property and `delete()` method to `Upload` type.

## [2.7.1] - 2023-10-30

__Fix:__ Reference to `uploads` object now targets `_db`, as it should, instead of `db`.

## [2.7.0] - 2023-10-27

__Add:__ `kitten.uploads` `delete()` method. 

## [2.6.0] - 2023-10-27

__Add:__ `Upload` type.

## [2.5.2] - 2023-10-27

__Fix:__ Upload type field name (`name` → `fileName`).

## [2.5.1] - 2023-10-21

__Fix:__ Method signatures for `KittenRequest`.

## [2.5.0] - 2023-10-04

__Add:__ Type information for Kitten internal uploads table (exposed publicly at `kitten.uploads`).

## [2.4.0] - 2023-09-20

__Change:__ Remove `Session` and `Upload` classes; they do not need to be public.

__Add:__ Type definitions for `KittenRequest`, `KittenPostRequest`, and `KittenResponse`. You can now take advantage of type safe request and response objects in your routes using these definitions.

## [2.3.2] - 2023-09-20

__Fix:__ Do not export `SessionInstance` and `UploadInstance` types as they are types, not values.

## [2.3.1] - 2023-09-19

__Fix:__ Use @typedefs to properly declare `SessionInstance` and `UploadInstance` classes.

## [2.3.0] - 2023-09-19

Add type safety for internal `_db` database and also expose `Session` and `Upload` classes and, [due to an unfortunate limitation of JSDoc](https://github.com/jsdoc/jsdoc/issues/1349#issuecomment-1725400751), `SessionInstance` and `UploadInstance` types as well.

## [2.2.0] - 2023-09-06

Add `domain`, `port`, `databaseDirectory`, `projectIdentifier`, `WebSocket`, and `Session` to default export.

Previously, these were kept out of the default export to reduce clutter during authoring but it actually leads to errors as the expectation is that the default export contents match the totality of the individually-exported objects.

The only exception to this at the moment is that the legacy all-uppercase library and page contants are not included in the default export as these are deprecated and included for now only for backwards compatibility.

## [2.1.0] - 2023-09-04

Add new Kitten internal `_db` database reference.

## [2.0.0] - 2023-08-23

__Breaking change:__ Use new `kitten` namespace.

## [1.2.0] - 2023-07-22

Add Events (global EventDispatcher instance).

## [1.1.0] - 2023-04-17

Page slot constants.

### Changed

  - Export [page slot constants](https://codeberg.org/kitten/app#special-page-slots) under `PAGE` object.

## [1.0.1] - 2023-04-14

Add types file to make TypeScript language server (LSP) happy.

### Changed

  - Add types for TypeScript Language Server.

## [1.0.0] - 2023-04-14

Initial release.
